/**
 * Copyright (c) 2017-present, Wonday (@wonday.org)
 * All rights reserved.
 *
 * This source code is licensed under the MIT-style license found in the
 * LICENSE file in the root directory of this source tree.
 */

#ifndef RCTPdfBoxView_h
#define RCTPdfBoxView_h

#if __has_include(<React/RCTAssert.h>)
#import <React/RCTEventDispatcher.h>
#import <React/UIView+React.h>
#else
#import "RCTEventDispatcher.h"
#import "UIView+React.h"
#endif


@class RCTEventDispatcher;

@interface RCTPdfBoxView : UIImageView <UIGestureRecognizerDelegate>

@property(nonatomic, strong) NSDictionary *coordinates;
@property(nonatomic, strong) NSDictionary *offset;
@property(nonatomic, strong) NSString *path;
@property(nonatomic) int pageId;
@property(nonatomic) int artId;
@property(nonatomic, strong) NSDictionary *pageSize;
@property(nonatomic) float scale;
@property(nonatomic) BOOL visible;

@property(nonatomic, copy) RCTBubblingEventBlock onPdfError;
@property(nonatomic, copy) RCTBubblingEventBlock onBoxDrawn;
- (CGRect) getCoordinatesRect;
- (UIImage *) cropImageAtScale:(float)scale;

@end

#endif /* RCTPdfView_h */
