/**
 * Copyright (c) 2017-present, Wonday (@wonday.org)
 * All rights reserved.
 *
 * This source code is licensed under the MIT-style license found in the
 * LICENSE file in the root directory of this source tree.
 */

#ifndef RCTPdfView_h
#define RCTPdfView_h

#if __has_include(<React/RCTAssert.h>)
#import <React/RCTEventDispatcher.h>
#import <React/UIView+React.h>
#else
#import "RCTEventDispatcher.h"
#import "UIView+React.h"
#endif

@class RCTEventDispatcher;

@interface RCTPdfView : UIView <UIGestureRecognizerDelegate>

@property(nonatomic, strong) NSString *path;
@property(nonatomic) int page;
@property(nonatomic) float scale;
@property(nonatomic) float offsetX;
@property(nonatomic) float offsetY;
@property(nonatomic) float minScale;
@property(nonatomic) float maxScale;
@property(nonatomic) BOOL isDoubleTruck;

@property(nonatomic, copy) RCTBubblingEventBlock onPdfLoaded;
@property(nonatomic, copy) RCTBubblingEventBlock onPdfError;
@property(nonatomic, copy) RCTBubblingEventBlock onPdfDrawn;

- (void)checkBoxes:(NSTimer *)timer;

@end

#endif /* RCTPdfView_h */
